<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/build-tools/render-elf-with-data/src/main.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>main.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../render_elf_with_data/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../render_elf_with_data/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../render_elf_with_data/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::fs</span>;

<span class="kw">use</span> <span class="ident">anyhow</span>::{<span class="ident">anyhow</span>, <span class="ident">ensure</span>, <span class="prelude-ty">Result</span>};
<span class="kw">use</span> <span class="ident">object</span>::{
    <span class="ident">elf</span>::{<span class="ident">ProgramHeader64</span>, <span class="ident">PF_R</span>, <span class="ident">PF_W</span>, <span class="ident">PT_LOAD</span>},
    <span class="ident">read::elf</span>::{<span class="ident">ElfFile64</span>, <span class="ident">ProgramHeader</span> <span class="kw">as</span> <span class="kw">_</span>},
    <span class="ident">write::elf</span>::{<span class="ident">FileHeader</span>, <span class="ident">ProgramHeader</span>, <span class="ident">Writer</span>},
    <span class="ident">Endian</span>, <span class="ident">Endianness</span>, <span class="ident">Object</span>, <span class="ident">ObjectSegment</span>, <span class="ident">ObjectSymbol</span>,
};

<span class="kw">mod</span> <span class="ident">args</span>;
<span class="kw">mod</span> <span class="ident">injection</span>;
<span class="kw">mod</span> <span class="ident">utils</span>;

<span class="kw">use</span> <span class="ident">args</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">injection</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">utils</span>::<span class="kw-2">*</span>;

<span class="kw">fn</span> <span class="ident">main</span>() -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">args</span> <span class="op">=</span> <span class="ident">Args::parse</span>()<span class="question-mark">?</span>;
    <span class="kw">if</span> <span class="ident">args</span>.<span class="ident">verbose</span> {
        <span class="macro">eprintln!</span>(<span class="string">&quot;{:#?}&quot;</span>, <span class="ident">args</span>);
    }
    <span class="kw">let</span> <span class="ident">injections</span> <span class="op">=</span> <span class="ident">args</span>
        .<span class="ident">injections</span>
        .<span class="ident">iter</span>()
        .<span class="ident">map</span>(<span class="ident">SymbolicInjection::from_arg</span>)
        .<span class="ident">collect</span>::<span class="op">&lt;</span><span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">SymbolicInjection</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>()<span class="question-mark">?</span>;
    <span class="kw">let</span> <span class="ident">in_file</span> <span class="op">=</span> <span class="ident">fs::read</span>(<span class="ident">args</span>.<span class="ident">in_file_path</span>)<span class="question-mark">?</span>;
    <span class="kw">let</span> <span class="ident">out_buf</span> <span class="op">=</span> <span class="ident">inject</span>(<span class="ident">in_file</span>.<span class="ident">as_slice</span>(), <span class="ident">injections</span>, <span class="kw-2">&amp;</span><span class="ident">args</span>.<span class="ident">image_bounds_symbols</span>)<span class="question-mark">?</span>;
    <span class="ident">fs::write</span>(<span class="ident">args</span>.<span class="ident">out_file_path</span>, <span class="kw-2">&amp;</span><span class="ident">out_buf</span>)<span class="question-mark">?</span>;
    <span class="prelude-val">Ok</span>(())
}

<span class="kw">struct</span> <span class="ident">InjectionMeta</span> {
    <span class="ident">offset</span>: <span class="ident">usize</span>,
    <span class="ident">p_align</span>: <span class="ident">usize</span>, <span class="comment">// TODO</span>
}

<span class="kw">fn</span> <span class="ident">inject</span>(
    <span class="ident">orig</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    <span class="ident">symbolic_injections</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">SymbolicInjection</span><span class="op">&gt;</span>,
    <span class="ident">image_bounds_symbols</span>: <span class="kw-2">&amp;</span><span class="ident">BoundsSymbolArgs</span>,
) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">orig_obj</span>: <span class="kw-2">&amp;</span><span class="ident">ElfFile64</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">ElfFile64::parse</span>(<span class="ident">orig</span>)<span class="question-mark">?</span>;
    <span class="kw">let</span> <span class="ident">orig_endian</span> <span class="op">=</span> <span class="ident">orig_obj</span>.<span class="ident">endian</span>();
    <span class="kw">let</span> <span class="ident">orig_image_end</span> <span class="op">=</span> <span class="ident">next_vaddr</span>(<span class="ident">orig_obj</span>)<span class="question-mark">?</span>.<span class="ident">try_into</span>()<span class="question-mark">?</span>;

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">out_buf</span> <span class="op">=</span> <span class="macro">vec!</span>[];
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">writer</span> <span class="op">=</span> <span class="ident">Writer::new</span>(<span class="ident">orig_endian</span>, <span class="ident">orig_obj</span>.<span class="ident">is_64</span>(), <span class="kw-2">&amp;mut</span> <span class="ident">out_buf</span>);

    <span class="ident">writer</span>.<span class="ident">reserve_file_header</span>();
    <span class="ident">writer</span>.<span class="ident">reserve_program_headers</span>(
        (<span class="ident">loadable_segments</span>(<span class="ident">orig_obj</span>).<span class="ident">count</span>() <span class="op">+</span> <span class="ident">symbolic_injections</span>.<span class="ident">len</span>()).<span class="ident">try_into</span>()<span class="question-mark">?</span>,
    );

    <span class="kw">let</span> <span class="ident">revised_offsets</span> <span class="op">=</span> <span class="ident">loadable_segments</span>(<span class="ident">orig_obj</span>)
        .<span class="ident">map</span>(<span class="op">|</span><span class="ident">phdr</span><span class="op">|</span> {
            <span class="kw">let</span> <span class="ident">offset</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="ident">phdr</span>.<span class="ident">p_offset</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>).<span class="ident">try_into</span>().<span class="ident">unwrap</span>();
            <span class="kw">let</span> <span class="ident">filesz</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="ident">phdr</span>.<span class="ident">p_filesz</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>).<span class="ident">try_into</span>().<span class="ident">unwrap</span>();
            <span class="kw">let</span> <span class="ident">align</span> <span class="op">=</span> <span class="ident">phdr</span>.<span class="ident">p_align</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>).<span class="ident">try_into</span>().<span class="ident">unwrap</span>();
            <span class="kw">let</span> <span class="ident">offset_within_alignment</span> <span class="op">=</span> <span class="ident">offset</span> <span class="op">%</span> <span class="ident">align</span>;
            <span class="ident">offset_within_alignment</span> <span class="op">+</span> <span class="ident">writer</span>.<span class="ident">reserve</span>(<span class="ident">offset_within_alignment</span> <span class="op">+</span> <span class="ident">filesz</span>, <span class="ident">align</span>)
        })
        .<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span><span class="op">&gt;</span>();

    <span class="kw">let</span> <span class="ident">new_segments</span> <span class="op">=</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">next_vaddr</span> <span class="op">=</span> <span class="ident">orig_image_end</span>;
        <span class="ident">symbolic_injections</span>
            .<span class="ident">into_iter</span>()
            .<span class="ident">map</span>(<span class="op">|</span><span class="ident">symbolic_injection</span><span class="op">|</span> {
                <span class="kw">let</span> <span class="ident">size</span> <span class="op">=</span> <span class="ident">symbolic_injection</span>.<span class="ident">size</span>();
                <span class="kw">let</span> <span class="ident">offset</span> <span class="op">=</span> <span class="ident">writer</span>.<span class="ident">reserve</span>(<span class="ident">size</span>, <span class="ident">symbolic_injection</span>.<span class="ident">align</span>());
                <span class="kw">let</span> <span class="ident">vaddr</span> <span class="op">=</span> <span class="ident">align_up</span>(<span class="ident">next_vaddr</span>, <span class="ident">symbolic_injection</span>.<span class="ident">align</span>());
                <span class="kw">let</span> <span class="ident">p_align</span> <span class="op">=</span> <span class="ident">symbolic_injection</span>.<span class="ident">align</span>(); <span class="comment">// TODO</span>
                <span class="ident">next_vaddr</span> <span class="op">=</span> <span class="ident">vaddr</span> <span class="op">+</span> <span class="ident">size</span>;
                <span class="prelude-val">Ok</span>((
                    <span class="ident">symbolic_injection</span>.<span class="ident">locate</span>(<span class="ident">vaddr</span>, <span class="ident">orig_endian</span>)<span class="question-mark">?</span>,
                    <span class="ident">InjectionMeta</span> { <span class="ident">offset</span>, <span class="ident">p_align</span> },
                ))
            })
            .<span class="ident">collect</span>::<span class="op">&lt;</span><span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span>(<span class="ident">Injection</span>, <span class="ident">InjectionMeta</span>)<span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>()<span class="question-mark">?</span>
    };

    <span class="ident">writer</span>.<span class="ident">write_file_header</span>({
        <span class="kw">let</span> <span class="ident">hdr</span> <span class="op">=</span> <span class="ident">orig_obj</span>.<span class="ident">raw_header</span>();
        <span class="kw-2">&amp;</span><span class="ident">FileHeader</span> {
            <span class="ident">os_abi</span>: <span class="ident">hdr</span>.<span class="ident">e_ident</span>.<span class="ident">os_abi</span>,
            <span class="ident">abi_version</span>: <span class="ident">hdr</span>.<span class="ident">e_ident</span>.<span class="ident">abi_version</span>,
            <span class="ident">e_type</span>: <span class="ident">hdr</span>.<span class="ident">e_type</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
            <span class="ident">e_machine</span>: <span class="ident">hdr</span>.<span class="ident">e_machine</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
            <span class="ident">e_entry</span>: <span class="ident">hdr</span>.<span class="ident">e_entry</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
            <span class="ident">e_flags</span>: <span class="ident">hdr</span>.<span class="ident">e_flags</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
        }
    })<span class="question-mark">?</span>;

    <span class="ident">writer</span>.<span class="ident">write_align_program_headers</span>();

    <span class="kw">for</span> (<span class="ident">phdr</span>, <span class="ident">revised_offset</span>) <span class="kw">in</span> <span class="ident">loadable_segments</span>(<span class="ident">orig_obj</span>).<span class="ident">zip</span>(<span class="kw-2">&amp;</span><span class="ident">revised_offsets</span>) {
        <span class="ident">writer</span>.<span class="ident">write_program_header</span>(<span class="kw-2">&amp;</span><span class="ident">ProgramHeader</span> {
            <span class="ident">p_type</span>: <span class="ident">phdr</span>.<span class="ident">p_type</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
            <span class="ident">p_flags</span>: <span class="ident">phdr</span>.<span class="ident">p_flags</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
            <span class="ident">p_offset</span>: (<span class="kw-2">*</span><span class="ident">revised_offset</span>).<span class="ident">try_into</span>()<span class="question-mark">?</span>,
            <span class="ident">p_vaddr</span>: <span class="ident">phdr</span>.<span class="ident">p_vaddr</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
            <span class="ident">p_paddr</span>: <span class="ident">phdr</span>.<span class="ident">p_paddr</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
            <span class="ident">p_filesz</span>: <span class="ident">phdr</span>.<span class="ident">p_filesz</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
            <span class="ident">p_memsz</span>: <span class="ident">phdr</span>.<span class="ident">p_memsz</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
            <span class="ident">p_align</span>: <span class="ident">phdr</span>.<span class="ident">p_align</span>.<span class="ident">get</span>(<span class="ident">orig_endian</span>),
        });
    }

    <span class="kw">for</span> (<span class="ident">injection</span>, <span class="ident">meta</span>) <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">new_segments</span> {
        <span class="kw">let</span> <span class="ident">offset</span> <span class="op">=</span> <span class="ident">meta</span>.<span class="ident">offset</span>.<span class="ident">try_into</span>()<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">vaddr</span> <span class="op">=</span> <span class="ident">injection</span>.<span class="ident">vaddr</span>().<span class="ident">try_into</span>()<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">size</span> <span class="op">=</span> <span class="ident">injection</span>.<span class="ident">size</span>().<span class="ident">try_into</span>()<span class="question-mark">?</span>;
        <span class="ident">writer</span>.<span class="ident">write_program_header</span>(<span class="kw-2">&amp;</span><span class="ident">ProgramHeader</span> {
            <span class="ident">p_type</span>: <span class="ident">PT_LOAD</span>,
            <span class="ident">p_flags</span>: <span class="ident">PF_R</span> <span class="op">|</span> <span class="ident">PF_W</span>,
            <span class="ident">p_offset</span>: <span class="ident">offset</span>,
            <span class="ident">p_vaddr</span>: <span class="ident">vaddr</span>,
            <span class="ident">p_paddr</span>: <span class="ident">vaddr</span>,
            <span class="ident">p_filesz</span>: <span class="ident">size</span>,
            <span class="ident">p_memsz</span>: <span class="ident">size</span>,
            <span class="ident">p_align</span>: <span class="ident">meta</span>.<span class="ident">p_align</span>.<span class="ident">try_into</span>()<span class="question-mark">?</span>,
        });
    }

    <span class="kw">for</span> (<span class="ident">phdr</span>, <span class="ident">revised_offset</span>) <span class="kw">in</span> <span class="ident">loadable_segments</span>(<span class="ident">orig_obj</span>).<span class="ident">zip</span>(<span class="kw-2">&amp;</span><span class="ident">revised_offsets</span>) {
        <span class="ident">writer</span>.<span class="ident">pad_until</span>(<span class="kw-2">*</span><span class="ident">revised_offset</span>);
        <span class="ident">writer</span>.<span class="ident">write</span>(
            <span class="ident">phdr</span>.<span class="ident">data</span>(<span class="ident">orig_endian</span>, <span class="ident">orig</span>)
                .<span class="ident">map_err</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="macro">anyhow!</span>(<span class="string">&quot;invalid&quot;</span>))<span class="question-mark">?</span>,
        );
    }

    <span class="kw">for</span> (<span class="ident">injection</span>, <span class="ident">meta</span>) <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">new_segments</span> {
        <span class="ident">writer</span>.<span class="ident">pad_until</span>(<span class="ident">meta</span>.<span class="ident">offset</span>);
        <span class="ident">writer</span>.<span class="ident">write</span>(<span class="ident">injection</span>.<span class="ident">content</span>());
    }

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">recorded</span>: <span class="ident">Vec</span><span class="op">&lt;</span>(<span class="ident">String</span>, <span class="ident">u64</span>)<span class="op">&gt;</span> <span class="op">=</span> <span class="macro">vec!</span>[];
    {
        <span class="kw">let</span> <span class="ident">image_start</span> <span class="op">=</span> <span class="ident">first_vaddr</span>(<span class="ident">orig_obj</span>)<span class="question-mark">?</span>.<span class="ident">try_into</span>()<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">image_end</span> <span class="op">=</span> <span class="ident">new_segments</span>
            .<span class="ident">iter</span>()
            .<span class="ident">map</span>(<span class="op">|</span>(<span class="ident">injection</span>, <span class="ident">_offset</span>)<span class="op">|</span> <span class="ident">injection</span>.<span class="ident">vaddr</span>() <span class="op">+</span> <span class="ident">injection</span>.<span class="ident">size</span>())
            .<span class="ident">max</span>()
            .<span class="ident">unwrap_or</span>(<span class="ident">orig_image_end</span>)
            .<span class="ident">try_into</span>()<span class="question-mark">?</span>;
        <span class="kw">for</span> <span class="ident">name</span> <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">image_bounds_symbols</span>.<span class="ident">start</span> {
            <span class="ident">recorded</span>.<span class="ident">push</span>((<span class="ident">name</span>.<span class="ident">clone</span>(), <span class="ident">image_start</span>))
        }
        <span class="kw">for</span> <span class="ident">name</span> <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">image_bounds_symbols</span>.<span class="ident">end</span> {
            <span class="ident">recorded</span>.<span class="ident">push</span>((<span class="ident">name</span>.<span class="ident">clone</span>(), <span class="ident">image_end</span>))
        }
        <span class="kw">for</span> <span class="ident">name</span> <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">image_bounds_symbols</span>.<span class="ident">size</span> {
            <span class="ident">recorded</span>.<span class="ident">push</span>((<span class="ident">name</span>.<span class="ident">clone</span>(), <span class="ident">image_end</span> <span class="op">-</span> <span class="ident">image_start</span>))
        }
    }
    <span class="kw">for</span> (<span class="ident">injection</span>, <span class="ident">_offset</span>) <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">new_segments</span> {
        <span class="kw">for</span> (<span class="ident">name</span>, <span class="ident">value</span>) <span class="kw">in</span> <span class="ident">injection</span>.<span class="ident">witnesses</span>() {
            <span class="ident">recorded</span>.<span class="ident">push</span>((<span class="ident">name</span>.<span class="ident">clone</span>(), <span class="kw-2">*</span><span class="ident">value</span>))
        }
    }

    <span class="kw">let</span> <span class="ident">out_obj</span>: <span class="kw-2">&amp;</span><span class="ident">ElfFile64</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">ElfFile64::parse</span>(<span class="ident">out_buf</span>.<span class="ident">as_slice</span>())<span class="question-mark">?</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">patches</span> <span class="op">=</span> <span class="macro">vec!</span>[];
    <span class="kw">for</span> (<span class="ident">name</span>, <span class="ident">value</span>) <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="ident">recorded</span> {
        <span class="kw">let</span> <span class="ident">patch_offset</span> <span class="op">=</span>
            <span class="ident">vaddr_to_offset</span>(<span class="ident">out_obj</span>, <span class="ident">get_symbol_vaddr</span>(<span class="ident">orig_obj</span>, <span class="ident">name</span>)<span class="question-mark">?</span>)<span class="question-mark">?</span>.<span class="ident">try_into</span>()<span class="question-mark">?</span>;
        <span class="kw">let</span> <span class="ident">value_bytes</span> <span class="op">=</span> <span class="ident">out_obj</span>.<span class="ident">endian</span>().<span class="ident">write_u64_bytes</span>(<span class="kw-2">*</span><span class="ident">value</span>);
        <span class="ident">patches</span>.<span class="ident">push</span>((<span class="ident">patch_offset</span>, <span class="ident">value_bytes</span>))
    }
    <span class="kw">for</span> (<span class="ident">patch_offset</span>, <span class="ident">value_bytes</span>) <span class="kw">in</span> <span class="ident">patches</span> {
        <span class="ident">out_buf</span>[<span class="ident">patch_offset</span>..<span class="ident">patch_offset</span> <span class="op">+</span> <span class="ident">value_bytes</span>.<span class="ident">len</span>()].<span class="ident">copy_from_slice</span>(<span class="kw-2">&amp;</span><span class="ident">value_bytes</span>);
    }

    <span class="prelude-val">Ok</span>(<span class="ident">out_buf</span>)
}

<span class="kw">fn</span> <span class="ident">loadable_segments</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(
    <span class="ident">obj</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">ElfFile64</span>,
) -&gt; <span class="kw">impl</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">ProgramHeader64</span><span class="op">&lt;</span><span class="ident">Endianness</span><span class="op">&gt;</span><span class="op">&gt;</span> {
    <span class="ident">obj</span>.<span class="ident">raw_segments</span>()
        .<span class="ident">iter</span>()
        .<span class="ident">filter</span>(<span class="op">|</span><span class="ident">phdr</span><span class="op">|</span> <span class="ident">phdr</span>.<span class="ident">p_type</span>.<span class="ident">get</span>(<span class="ident">obj</span>.<span class="ident">endian</span>()) <span class="op">==</span> <span class="ident">PT_LOAD</span>)
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_symbol_vaddr</span>(<span class="ident">obj</span>: <span class="kw-2">&amp;</span><span class="ident">ElfFile64</span>, <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span> {
    <span class="kw">for</span> <span class="ident">symbol</span> <span class="kw">in</span> <span class="ident">obj</span>.<span class="ident">symbols</span>() {
        <span class="kw">if</span> <span class="ident">symbol</span>.<span class="ident">name</span>()<span class="question-mark">?</span> <span class="op">==</span> <span class="ident">name</span> {
            <span class="macro">ensure!</span>(<span class="ident">symbol</span>.<span class="ident">size</span>() <span class="op">==</span> <span class="number">8</span>);
            <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">symbol</span>.<span class="ident">address</span>());
        }
    }
    <span class="prelude-val">Err</span>(<span class="macro">anyhow!</span>(<span class="string">&quot;symbol &#39;{}&#39; not present&quot;</span>, <span class="ident">name</span>))
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">vaddr_to_offset</span>(<span class="ident">obj</span>: <span class="kw-2">&amp;</span><span class="ident">ElfFile64</span>, <span class="ident">vaddr</span>: <span class="ident">u64</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span> {
    <span class="kw">for</span> <span class="ident">segment</span> <span class="kw">in</span> <span class="ident">obj</span>.<span class="ident">segments</span>() {
        <span class="kw">let</span> <span class="ident">start</span> <span class="op">=</span> <span class="ident">segment</span>.<span class="ident">address</span>();
        <span class="kw">let</span> <span class="ident">end</span> <span class="op">=</span> <span class="ident">start</span> <span class="op">+</span> <span class="ident">segment</span>.<span class="ident">size</span>();
        <span class="kw">if</span> (<span class="ident">start</span>..<span class="ident">end</span>).<span class="ident">contains</span>(<span class="kw-2">&amp;</span><span class="ident">vaddr</span>) {
            <span class="kw">let</span> <span class="ident">offset_in_segment</span> <span class="op">=</span> <span class="ident">vaddr</span> <span class="op">-</span> <span class="ident">start</span>;
            <span class="kw">let</span> (<span class="ident">file_start</span>, <span class="ident">file_size</span>) <span class="op">=</span> <span class="ident">segment</span>.<span class="ident">file_range</span>();
            <span class="macro">ensure!</span>(<span class="ident">offset_in_segment</span> <span class="op">&lt;</span> <span class="ident">file_size</span>);
            <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">file_start</span> <span class="op">+</span> <span class="ident">offset_in_segment</span>);
        }
    }
    <span class="prelude-val">Err</span>(<span class="macro">anyhow!</span>(<span class="string">&quot;vaddr &#39;0x{:x}&#39; not mapped&quot;</span>, <span class="ident">vaddr</span>))
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">first_vaddr</span>(<span class="ident">obj</span>: <span class="kw-2">&amp;</span><span class="ident">ElfFile64</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span> {
    <span class="ident">loadable_segments</span>(<span class="ident">obj</span>)
        .<span class="ident">map</span>(<span class="op">|</span><span class="ident">phdr</span><span class="op">|</span> <span class="ident">phdr</span>.<span class="ident">p_vaddr</span>.<span class="ident">get</span>(<span class="ident">obj</span>.<span class="ident">endian</span>()))
        .<span class="ident">min</span>()
        .<span class="ident">ok_or</span>(<span class="macro">anyhow!</span>(<span class="string">&quot;no segments&quot;</span>))
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">next_vaddr</span>(<span class="ident">obj</span>: <span class="kw-2">&amp;</span><span class="ident">ElfFile64</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span> {
    <span class="ident">loadable_segments</span>(<span class="ident">obj</span>)
        .<span class="ident">map</span>(<span class="op">|</span><span class="ident">phdr</span><span class="op">|</span> <span class="ident">phdr</span>.<span class="ident">p_vaddr</span>.<span class="ident">get</span>(<span class="ident">obj</span>.<span class="ident">endian</span>()) <span class="op">+</span> <span class="ident">phdr</span>.<span class="ident">p_memsz</span>.<span class="ident">get</span>(<span class="ident">obj</span>.<span class="ident">endian</span>()))
        .<span class="ident">max</span>()
        .<span class="ident">ok_or</span>(<span class="macro">anyhow!</span>(<span class="string">&quot;no segments&quot;</span>))
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="render_elf_with_data" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>